#!/usr/bin/python
# -*- coding: utf-8 -*-

###################################################
#
#        wto est un programme permettant de regarder la WebTv d'Orange (sans Firefox),
#		 Ce programme est basé sur le script bash écrit par papaneo (http://forum.ubuntu-fr.org/profile.php?id=117523)
#        
#        Copyright 2008 Tuxgasy <tuxgasy@tuxfamily.org>
#        Copyright 2010 Loïc GRENON <difool@tuxfamily.org>
#
#        This program is free software; you can redistribute it and/or modify
#        it under the terms of the GNU General Public License as published by
#        the Free Software Foundation; either version 3 of the License, or
#        (at your option) any later version.
#        
#        This program is distributed in the hope that it will be useful,
#        but WITHOUT ANY WARRANTY; without even the implied warranty of
#        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#        GNU General Public License for more details.
#        
#        You should have received a copy of the GNU General Public License
#        along with this program; if not, write to the Free Software
#        Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#        MA 02110-1301, USA.
#
###################################################

# Gtk
import gtk, gobject

# fonctions système
import os, subprocess, time

# requêtes HTTP
import cookielib, urllib2

# parseur de config valeur-cle
import ConfigParser

# parse XML
import xml.dom.minidom

# Expression regulière
import re

# thread
import thread

# initialisation des threads
gtk.gdk.threads_init()

# Variables globales
WTO_VERSION = '1.0'
WTO_ICON = "/usr/share/pixmaps/wto.png"
if not os.access(WTO_ICON,os.F_OK) :
	WTO_ICON = "pixmaps/wto.png"
if not os.access(WTO_ICON,os.F_OK) :
	WTO_ICON = "../pixmaps/wto.png"
WTO_USER_HOME = os.path.expanduser("~/.wto")
WTO_LOCK_FILE = WTO_USER_HOME+'/wto.lock'
WTO_CONF = WTO_USER_HOME+'/wto.conf'
WTO_RECORDS_DIR = WTO_USER_HOME+'/records'
WTO_CACHE_DIR = WTO_USER_HOME+'/cache'
WTO_COOKIES_FILE = WTO_CACHE_DIR+'/cookies'
WTO_CHANNELS_ICONS = WTO_CACHE_DIR+'/icons'

# Developpeurs et artistes
WTO_AUTHORS = ['Papaneo', 'TuxGasy (alias UgM) <tuxgasy@tuxfamily.org>', 'Loïc GRENON <difool@tuxfamily.org>']
WTO_ARTISTS = ['TuxGasy <tuxgasy@tuxfamily.org>']
WTO_LICENSE = """
Wto est un logiciel libre ; vous pouvez le redistribuer et/ou
le modifier selon les termes de la Licence Publique Générale GNU
publiée par la Free Software Foundation ; soit la version 3 de la
license, soit (à votre discrétion) toute version ultérieure.

Wto est distribué dans l'espoir qu'il puisse vous être utile,
mais SANS AUCUNE GARANTIE ; sans même la garantie de VALEUR MARCHANDE
ou d'ADÉQUATION À UN BESOIN PARTICULIER. Consultez la Licence Publique
Générale GNU pour plus de détails.

Vous devez avoir reçu une copie de la Licence Publique Générale GNU
en même temps que Wto ; si ce n'est pas le cas, écrivez à la
Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, États-Unis.
"""

#Le User-Agent que l'on va utiliser pour les requetes. Ce n'est pas le meme que j'envoi plus tard a leur
#appli pour tester notre configuration (j'ai utilise plusieures machines) mais ca n'a pas l'air de poser
#probleme. Vous pouvez toujours le changer au pire ;)
USER_AGENT = 'WTO '+WTO_VERSION
ORANGE_DWR_URL = 'http://webtv.guidetv.orange.fr/dwr/call/plaincall/'

class Channels :
	" Class Channels "
	
	def getChannelsInfos(self) :
		print 'Recuperation de la liste des chaines...'
		
		# On récupère les cookies Orange (wassup et service)
		request = urllib2.Request("http://webtv.guidetv.orange.fr/j_acegi_wassup_security_check?dub=1")
		self.urlOpener.open(request)  # Notre cookiejar reçoit automatiquement les cookies
		
		# On récupère la liste des chaines (fichier: channelsInfos.do)
		request = urllib2.Request("http://webtv.guidetv.orange.fr/channelsInfos.do")
		url = self.urlOpener.open(request)  # Notre cookiejar reçoit automatiquement les cookies
		channels_info = url.read()

		self.dom = xml.dom.minidom.parseString(channels_info)
		self.root = self.dom.getElementsByTagName('artworkinfo')
	
	# Fonctions pour parser le fichier xml de la liste des chaines (channelsInfos.do)
	def getTextNode(self, nodelist) :
		rc = ""
		for node in nodelist:
			if node.nodeType == node.TEXT_NODE :
				rc = rc+node.data
		
		return rc

	def getArtName(self, idElement=0, download=False) :
		try :
			artLocationDom = self.dom.getElementsByTagName('artLocation')[idElement]
			artLocation = self.getTextNode(artLocationDom.childNodes)
			
			m = os.path.split(artLocation)
			artName = m[1]
			
			if download and not  os.access(WTO_CHANNELS_ICONS+'/'+artName, os.F_OK) :
				request = urllib2.Request("http://webtv.guidetv.orange.fr/"+artLocation)
				url = self.urlOpener.open(request)
				oFile = open(WTO_CHANNELS_ICONS+'/'+artName, 'w')
				oFile.write(url.read())
				oFile.close()
			
			return artName
		
		except IndexError :
			return None

	def getChaine(self, idElement=0) :
		try :
			chaineDom = self.dom.getElementsByTagName('chaine')[idElement]
			return self.getTextNode(chaineDom.childNodes)
		
		except IndexError :
			return None

	def getPrgEnCours(self, idElement=0) :
		try :
			prgEnCoursDom = self.dom.getElementsByTagName('prgEnCours')[idElement]
			return self.getTextNode(prgEnCoursDom.childNodes)
			
		except IndexError :
			return None

	def getId(self, idElement=0) :
		try :
			idDom = self.dom.getElementsByTagName('id')[idElement]
			return self.getTextNode(idDom.childNodes)
		
		except IndexError :
			return None

	def getDuree(self, idElement=0) :
		try :
			dureeDom = self.dom.getElementsByTagName('duree')[idElement]
			return self.getTextNode(dureeDom.childNodes)
		
		except IndexError :
			return None

	def getAnnee(self, idElement=0) :
		try :
			anneeDom = self.dom.getElementsByTagName('annee')[idElement]
			return self.getTextNode(anneeDom.childNodes)
		
		except IndexError :
			return None

	def getPrgAvenir(self, idElement=0) :
		try :
			prgAvenirDom = self.dom.getElementsByTagName('prgAvenir')[idElement]
			return self.getTextNode(prgAvenirDom.childNodes)
		
		except IndexError :
			return None

	def showChannels(self) :
		print 'Liste des chaines :'
		
		idElement=0
		while self.getId(idElement) :
			print idElement, ' : ', self.getChaine(idElement), '(en cours "', self.getPrgEnCours(idElement),'")'
			self.getArtName(idElement, False)
			idElement=idElement+1
	
	def getSessionId(self) :
		'''
		Extraction du JSESSIONID à partir du cookie
		'''
		for cookie in self.cookiejar:
			if cookie.name == "JSESSIONID":
				return cookie.value
	
	def computeBandWidth(self) :
		'''
		Calcul de la bande passante disponible en kb/s
		'''
		startDownloadTime = time.time()
		
		request = urllib2.Request("http://webtv.guidetv.orange.fr/bandwidth_512KO.bin")
		url = self.urlOpener.open(request)
		url.read()

		endDownloadTime = time.time()

		sizeToDownloadInBits = 4194304	# 512 ko = 512 * 1024 * 8
		delayFileDL = endDownloadTime - startDownloadTime
		Debit=(sizeToDownloadInBits/delayFileDL) / 1024
		bandwidthInKiloBitsPerSeconds = round((Debit *10 ) / 10)

		return int(bandwidthInKiloBitsPerSeconds)
	
	def sendClientConfiguration(self) :
		'''
		Envoi de la configuration du client (Bande passante disponible, user_agent, version de WMP, des DRM, de VLC ...) au serveur Orange.
		'''
		# On ecrit la fausse configuration que l'on va envoyer
		data = """callCount=1
page=/home.do
httpSessionId="""+str(self.getSessionId())+"""
scriptSessionId=67F94E59E0FEB57D194FE35CE43EB227420
c0-scriptName=WebConfigurationCollectorService
c0-methodName=storeCompleteDetectedClientConfiguration
c0-id=0
c0-e1=number:"""+str(self.computeBandWidth())+"""
c0-e2=string:Mozilla%2F5.0%20(X11%3B%20U%3B%20Linux%20x86_64%3B%20fr%3B%20rv%3A1.9.1.6)%20Gecko%2F20100107%20Fedora%2F3.5.6-1.fc12%20Firefox%2F3.0
c0-e3=string:N%2FA
c0-e4=null:null
c0-e5=string:N%2FA
c0-e6=string:N%2FA
c0-e7=string:N%2FA
c0-e8=string:N%2FA
c0-e9=boolean:false
c0-param0=Object_Object:{bandwidth:reference:c0-e1, userAgent:reference:c0-e2, wmpVersion:reference:c0-e3, minorVersionNavigator:reference:c0-e4, drmVersion:reference:c0-e5, drmSecurityVersion:reference:c0-e6, drmSecurityVersionFor3_6_0_1:reference:c0-e7, vlcVersion:reference:c0-e8, activeXCoppInstalled:reference:c0-e9}
batchId=0"""
		
		# On envoie la fausse configuration (notre cookiejar reￃﾧoit automatiquement les cookies)
		request = urllib2.Request(ORANGE_DWR_URL, data)
		self.urlOpener.open(request)
		
		# On recupere à nouveau les cookies Orange (wassup et service)
		# Nￃﾩcessaire pour certains abonnￃﾩs d'Orange (va savoir pourquoi?!)
		request = urllib2.Request("http://wassup.orange.fr/?wassup=ident&ndrtc_idp=EXTERNAL&serv=VIDEOC&formtype=iden&info=uid,sau,dsn,uip,cooser,cooses,uas,ufn,uln,ugn,ute,uty,cms,ulo,lulo,clo,sai,lndrtc&inter=LIT&prot=302&returl=http%3A%2F%2Fwebtv.guidetv.orange.fr%2Fj_acegi_wassup_security_check%3Fdub%3D1&nivid=acco")
		self.urlOpener.open(request)
	
	def JSON_decode(self, string) :
		'''
		Fonction permettant de décoder le « pseudo JSON » retourné dans les fonctions de retour du moteur DWR
		'''
		# On récupère le « pseudo JSON »
		match_obj = re.search(r"dwr.engine._remoteHandleCallback\([^,]*,[^,]*,{([^)]*)}\)", string)
		return dict([json_val.split(':') for json_val in match_obj.group(1).split(',')])

	def getChannelAuthorization(self, idChannel) :
		'''
		Fonction permettant de savoir si on est autorisé ou non à visualiser la chaîne.
		'''
		# On interroge le serveur
		data = """callCount=1
page=/home.do?action=generateSelectedChannelUrlForQuarterAndFullScreen&fullScreen=false&channelGuid=2&time=1266762304606&visualisationMode=OTVC
httpSessionId="""+str(self.getSessionId())+"""
scriptSessionId=67F94E59E0FEB57D194FE35CE43EB227420
c0-scriptName=WebChannelService
c0-methodName=getChannelAuthorizationByGuid
c0-id=0
c0-param0=string:"""+str(idChannel)+"""
batchId=0"""
		request = urllib2.Request(ORANGE_DWR_URL, data)
		url = self.urlOpener.open(request)
		response = url.read()

		# On récupère le « pseudo JSON »
		json = self.JSON_decode(response)

		# On va chercher la valeur du « pseudo JSON » qui nous intéresse
		if json['authorized'] == 'true' :
			return True
		else :
			return False
		
	def refreshSession(self) :
		'''
		Rafraichissement de la session en cours
		'''
		data = """callCount=1
page=/home.do?action=generateSelectedChannelUrlForQuarterAndFullScreen&fullScreen=false&channelGuid=2&time=1266762304606&visualisationMode=OTVC
httpSessionId="""+str(self.getSessionId())+"""
scriptSessionId=67F94E59E0FEB57D194FE35CE43EB227420
c0-scriptName=WebSystemService
c0-methodName=refreshSession
c0-id=0
batchId=0"""
		request = urllib2.Request(ORANGE_DWR_URL, data)
		self.urlOpener.open(request)
	
	def getChannelUrl(self, idChannel, highquality=False) :
		print 'Recuperation de l\'url...'
		
		# On rafraichit la session
		self.refreshSession()
		
		#On va chercher notre url mms tant desiree :)
		request = urllib2.Request("http://webtv.guidetv.orange.fr/secured/getGenerateChannelUrl.ajax?action=generateSelectedChannelUrlForQuarterAndFullScreen&fullScreen=%s&channelGuid=%s&time=%i&visualisationMode=OTVC" % (('true' if highquality else 'false'), idChannel, round(time.time()*1000)))
		try :
			url = self.urlOpener.open(request)
			url_mms = url.read()
			print url_mms
		except urllib2.HTTPError, e :
			print "Code d'erreur : %s - %s" % (e.code, e.msg)
			url_mms = None
		
		return url_mms
	
	def __init__(self) :
		# On active le support des cookies pour urllib2
		self.cookiejar = cookielib.CookieJar()
		self.urlOpener = urllib2.build_opener(urllib2.HTTPCookieProcessor(self.cookiejar))

		self.getChannelsInfos()

class MainIterface :
	
	config = None
	window, menu, listChannels, statusBar, controlBox = None, None, None, None, None
	ch, player = None, None
	
	def quit(self, widget, data=None) :
		if self.player != None :
			self.player.stop()
		gtk.main_quit()
	
	def initListChannels(self) :
		gtk.gdk.threads_enter()
		self.statusBar.addText("Recuperation de la liste des chaines en cours...")
		gtk.gdk.threads_leave()
		try:
			self.ch = Channels()
			self.ch.sendClientConfiguration()
			self.showListChannels()
			gtk.gdk.threads_enter()
			self.statusBar.addText("Recuperation de la liste des chaines... Ok")
			gtk.gdk.threads_leave()
		except urllib2.URLError :
			gtk.gdk.threads_enter()
			self.statusBar.addText("Problème de connexion")
			gtk.gdk.threads_leave()
			print "Problème de connexion"
		
		# Mise à jour périodique (toutes les minutes) de la liste des chaînes
		gobject.timeout_add(60000, self.onUpdateListChannels, None)
	
	def showListChannels(self) :
		idElement=0
		gtk.gdk.threads_enter()
		# id chaine, logo, chaine, programme en cours, programme à venir, duree
		listStore = gtk.ListStore(int, gtk.gdk.Pixbuf, str, str, str, str)
		gtk.gdk.threads_leave()
		while self.ch.getId(idElement) :
			iconChannel = self.ch.getArtName(idElement, True)
			gtk.gdk.threads_enter()
			pixbufIconChannel = gtk.gdk.pixbuf_new_from_file(WTO_CHANNELS_ICONS+'/'+iconChannel)
			pixbufIconChannel = pixbufIconChannel.scale_simple(25, 25, gtk.gdk.INTERP_BILINEAR)
			listStore.append([idElement, pixbufIconChannel, self.ch.getChaine(idElement), self.ch.getPrgEnCours(idElement), self.ch.getPrgAvenir(idElement), self.ch.getDuree(idElement)])
			gtk.gdk.threads_leave()
			idElement = idElement+1
		gtk.gdk.threads_enter()
		self.listChannels.treeview.set_model(listStore)
		gtk.gdk.threads_leave()
	
	def onUpdateListChannels(self, widget, data=None) :
		thread.start_new_thread(self.updateListChannels, ())
		return True
	
	def onUpdateAllListChannels(self, widget, data=None) :
		thread.start_new_thread(self.updateListChannels, (True,))
	
	def updateListChannels(self, download_icon=False) :
		gtk.gdk.threads_enter()
		self.statusBar.addText("Mise à jour de la liste des chaines en cours...")
		gtk.gdk.threads_leave()
		if download_icon :
			listdir = os.listdir(WTO_CHANNELS_ICONS)
			for file in listdir :
				os.remove(WTO_CHANNELS_ICONS+'/'+file)
		self.ch.getChannelsInfos()
		self.showListChannels()
		gtk.gdk.threads_enter()
		self.statusBar.addText("Mise à jour de la liste des chaines... Ok")
		gtk.gdk.threads_leave()
		
		return True
	
	def onToggleHighQuality(self, widget, data=None) :
		if self.config.config.getboolean('general', 'highvideoquality') :
			self.config.config.set('general', 'highvideoquality', 'false')
		else :
			self.config.config.set('general', 'highvideoquality', 'true')
		self.config.config.write(open(WTO_CONF, 'wb'))
	
	def showChannel(self, idElement) :
		print 'Lancement de la chaine n°'+str(idElement)+' ('+self.ch.getChaine(idElement)+')...'
		self.statusBar.addText('Lancement de '+self.ch.getChaine(idElement)+'...')
		idChannel = self.ch.getId(idElement)
		if self.player != None :
			self.player.stop()
		if self.ch.getChannelAuthorization(idChannel) :
			player_options = self.config.config.get('player', 'options')
			highquality = self.config.config.getboolean('general', 'highvideoquality')
			channel_url = self.ch.getChannelUrl(idChannel, highquality)
			self.player = Mplayer(channel_url, player_options)
		else :
			message = "Cette chaine ne fait pas partie de votre abonnement.\nPour plus de renseignements, rendez-vous sur la boutique en ligne Orange."
			print message
			gtk.gdk.threads_enter()
			self.showMessageDialog(message)
			gtk.gdk.threads_leave()
	
	def recordChannel(self, idElement) :
		print 'Enregistrement de la chaine n°'+str(idElement)+' ('+self.ch.getChaine(idElement)+')...'
		self.statusBar.addText('Enregistrement de '+self.ch.getChaine(idElement)+'...')
		# Format du nom du fichier record_JJ-MM-AAAA_HH-MM-SS.wmv
		output_file = WTO_RECORDS_DIR+'/record'+'_'+time.strftime("%d-%m-%Y_%H-%M-%S", time.gmtime())+'.wmv'
		idChannel = self.ch.getId(idElement)
		self.record = Record(self.ch.getChannelUrl(idChannel), output_file)

	def showMessageDialog(self, message) :
		dialog = gtk.MessageDialog(self.window, gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, message)
		response = dialog.run()
		dialog.destroy()
		return response
	
	def __init__(self, config) :
		self.config = config
		print 'Initialisation de la fenêtre principale...'
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.connect("destroy", self.quit)
		self.window.set_title('wto '+WTO_VERSION)
		self.window.set_default_size(350, 500)
		
		if os.access(WTO_ICON,os.F_OK) :
			self.window.set_icon(gtk.gdk.pixbuf_new_from_file(WTO_ICON))
		
		vbox = gtk.VBox(False, True)
		self.window.add(vbox)
		
		# Barre de menu
		self.menu = MenuInterface(self)
		vbox.pack_start(self.menu.menu_bar, False, True, 5)
		
		# Controle de Mplayer
		#self.controlBox = ControlInterface(self)
		#vbox.pack_start(self.controlBox.hbox, False, True, 5)
		
		# box contenant la liste des chaines
		self.listChannels = ListChannelsInterface(self)
		vbox.pack_start(self.listChannels.channelsBox, True, True, 5)
		
		# Barre d'état
		self.statusBar = StatusBarInterface(self)
		self.statusBar.addText("Wto "+WTO_VERSION)
		vbox.pack_start(self.statusBar.status_bar, False, True, 0)
		
		self.window.show_all()
		
		thread.start_new_thread(self.initListChannels, ())

		gtk.main()

class Config :
	
	config = None
	
	def __init__(self) :
		self.config = ConfigParser.ConfigParser()
		if not os.access(WTO_CONF, os.F_OK | os.W_OK) :
			self.config.add_section('general')
			self.config.set('general', 'highvideoquality', 'false')
			
			self.config.add_section('player')
			self.config.set('player', 'options', '-cache 400 -cache-min 90')
			
			self.config.write(open(WTO_CONF, 'wb'))
		else :
			self.config.read(WTO_CONF)
			try :
				self.config.getboolean('general', 'highvideoquality')
			except :
				self.config.add_section('general')
				self.config.set('general', 'highvideoquality', 'false')
				self.config.write(open(WTO_CONF, 'wb'))

class MenuInterface :
	
	menu_bar = None
	
	def __init__(self, data) :
		# Barre de menu
		self.menu_bar = gtk.MenuBar()
		
		# Menu Fichier
		menu = gtk.Menu()
		accel = gtk.AccelGroup()
		menu_item = gtk.MenuItem(label="_Fichier")
		menu_item.set_submenu(menu)
		self.menu_bar.append(menu_item)
		
		# Les éléments du menu Fichier
		menu_item = gtk.ImageMenuItem(gtk.STOCK_QUIT, accel)
		menu_item.set_tooltip_text('Quitter wto')
		menu_item.connect("activate", data.quit)
		menu.append(menu_item)
		
		# Menu Enregistrement
		#menu = gtk.Menu()
		#menu_item = gtk.MenuItem(label="_Enregistrement")
		#menu_item.set_submenu(menu)
		#self.menu_bar.append(menu_item)
		
		# Les éléments du menu Enregistrement
		#menu_item = gtk.MenuItem("Ajouter un enregistrement...")
		#menu_item.set_sensitive(False)
		#menu_item.set_tooltip_text('Enregistrer une chaine')
		#self.menu_item_add_record = menu_item
		#menu_item.connect("activate", self.onAddRecord)
		#menu.append(menu_item)
		
		#menu_item = gtk.MenuItem("Liste des enregistrements...")
		#menu_item.set_tooltip_text('Listes de vos enregistrements')
		#menu_item.connect("activate", self.onShowListRecord)
		#menu.append(menu_item)
		
		# Menu Affichage
		menu = gtk.Menu()
		menu_item = gtk.MenuItem(label="_Affichage")
		menu_item.set_submenu(menu)
		self.menu_bar.append(menu_item)
		
		# Les éléments du menu Affichage
		menu_item = gtk.ImageMenuItem(stock_id=gtk.STOCK_REFRESH)
		menu_item.set_tooltip_text('Actualiser la liste des chaines')
		menu_item.connect("activate", data.onUpdateListChannels)
		menu.append(menu_item)
		
		menu_item = gtk.MenuItem('Actualiser tous')
		menu_item.set_tooltip_text('Actualiser la liste des chaines en retéléchargeant les icônes')
		menu_item.connect("activate", data.onUpdateAllListChannels)
		menu.append(menu_item)

		menu_item = gtk.CheckMenuItem('Haute qualité')
		menu_item.set_active(data.config.config.getboolean('general', 'highvideoquality'))
		menu_item.set_tooltip_text('Visualiser les vidéos en haute qualité')
		menu_item.connect("toggled", data.onToggleHighQuality)
		menu.append(menu_item)
		
		# Menu ?
		menu = gtk.Menu()
		menu_item = gtk.MenuItem(label="?")
		menu_item.set_submenu(menu)
		self.menu_bar.append(menu_item)
		
		# Les éléments du menu ?
		menu_item = gtk.ImageMenuItem(stock_id=gtk.STOCK_ABOUT)
		menu_item.set_tooltip_text('A propos de wto')
		menu_item.connect("activate", About, data)
		menu.append(menu_item)
		
		data.window.add_accel_group(accel)

class ControlInterface :
	
	hbox, btn_previous, btn_play, btn_stop, btn_record, btn_next = None, None, None, None, None, None
	
	def OnActiveRecord(self, widget, data=None) :
		if widget.get_active() :
			print 'enregistrer...'
		else :
			print 'stop enregistrement...'
	
	def __init__(self, data) :
		self.hbox = gtk.HBox(True, 0)
		
		self.hbox.hide()
		
		self.btn_previous = gtk.ToolButton(stock_id=gtk.STOCK_MEDIA_PREVIOUS)
		self.btn_previous.set_sensitive(False)
		self.hbox.pack_start(self.btn_previous, True, True, 0)
		
		self.btn_play = gtk.ToolButton(stock_id=gtk.STOCK_MEDIA_PLAY)
		self.btn_play.set_sensitive(False)
		self.hbox.pack_start(self.btn_play, True, True, 0)
		
		self.btn_stop = gtk.ToolButton(stock_id=gtk.STOCK_MEDIA_STOP)
		self.btn_stop.set_sensitive(False)
		self.hbox.pack_start(self.btn_stop, True, True, 0)
		
		self.btn_record = gtk.ToggleToolButton(stock_id=gtk.STOCK_MEDIA_RECORD)
		#self.btn_record.set_sensitive(False)
		self.btn_record.connect("toggled", self.OnActiveRecord)
		self.hbox.pack_start(self.btn_record, True, True, 0)
		
		self.btn_next = gtk.ToolButton(stock_id=gtk.STOCK_MEDIA_NEXT)
		self.btn_next.set_sensitive(False)
		self.hbox.pack_start(self.btn_next, True, True, 0)
		

class About :
	"Fenêtre about"
	
	about = None
	
	def __init__(self, widget, wto) :
		about = gtk.AboutDialog()
		if os.access(WTO_ICON,os.F_OK) :
			about.set_icon(gtk.gdk.pixbuf_new_from_file(WTO_ICON))
			about.set_logo(gtk.gdk.pixbuf_new_from_file(WTO_ICON))
		about.set_authors(WTO_AUTHORS)
		about.set_artists(WTO_ARTISTS)
		about.set_license(WTO_LICENSE)
		about.set_name('Wto')
		about.set_version(WTO_VERSION)
		about.set_comments('Wto est un logiciel libre permettant de regarder la\n Web Tv d\'Orange avec Mplayer sans navigateur\n (tel que Firefox)')
		about.set_copyright('Copyright (c) 2009 - Papaneo, TuxGasy (alias UgM)\nCopyright (c) 2010 - Loïc GRENON')
		about.set_website('http://wto.tuxfamily.org')
		
		about.run()
		about.destroy()

class ListChannelsInterface :
	
	channelsBox = None
	
	def onActiveRow(self, treeview, path, view_column, data) :
		thread.start_new_thread(data.showChannel, (path[0],))

	def on_query_tooltip(self, treeview, x, y, keyboard_tip, tooltip):
		if not treeview.get_tooltip_context(x, y, keyboard_tip):
			return False
		else:
			model, path, iter = treeview.get_tooltip_context(x, y, keyboard_tip)
			
			chaine = model.get(iter, 2)[0]
			pgm_en_cours = model.get(iter, 3)[0]
			pgm_a_venir = model.get(iter, 4)[0]
			duree = model.get(iter, 5)[0]

			tooltip.set_text(chaine+"\n"+pgm_en_cours+"\nDurée : "+duree+"\nÀ venir : "+pgm_a_venir)
			treeview.set_tooltip_row(tooltip, path)
			return True
	
	def __init__(self, data) :
		scroll_bar = gtk.ScrolledWindow()
		scroll_bar.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
		self.channelsBox = scroll_bar
		
		listStore = gtk.ListStore(int, gtk.gdk.Pixbuf, str, str, str, str)    # Ce ListStore ne sert qu'à pouvoir afficher le Treeview dès le lancement de l'appli
		treeview = gtk.TreeView()
		treeview.set_model(listStore)
		self.treeview = treeview
		treeview.props.has_tooltip = True
		treeview.connect("row-activated", self.onActiveRow, data)
		treeview.connect("query-tooltip", self.on_query_tooltip)
		scroll_bar.add_with_viewport(treeview)
		
		cell = gtk.CellRendererText()
		column = gtk.TreeViewColumn('N°', cell, text=0)
		column.set_visible(False)
		treeview.append_column(column)
		
		cell = gtk.CellRendererPixbuf()
		column = gtk.TreeViewColumn('', cell, pixbuf=1)
		treeview.append_column(column)
		
		cell = gtk.CellRendererText()
		column = gtk.TreeViewColumn('Chaines', cell, text=2)
		treeview.append_column(column)
		
		cell =gtk.CellRendererText()
		column = gtk.TreeViewColumn('Programme en cours', cell, text=3)
		treeview.append_column(column)
		
		cell =gtk.CellRendererText()
		column = gtk.TreeViewColumn('Programme suivant', cell, text=4)
		treeview.append_column(column)

class StatusBarInterface :
	
	status_bar, context_id = None, None
	
	def addText(self, msg) :
		self.status_bar.push(self.context_id, msg)
	
	def __init__(self, data) :
		self.status_bar = gtk.Statusbar()
		self.status_bar.show_all()
		self.context_id = self.status_bar.get_context_id("ShowChannel")

class Mplayer :
	
	mplayer = None
	
	def play(self, url, options) :
		self.stop()
		cmd = 'mplayer -slave -idle -quiet '+options+' '+url
		self.mplayer = subprocess.Popen(cmd, shell=True, bufsize=0, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, close_fds=True)
	
	def pause(self) :
		if self.mplayer != None and self.mplayer.poll() == None :
			self.mplayer.stdin.write('pause\n')
		
	def stop(self) :
		if self.mplayer != None and self.mplayer.poll() == None :
			self.mplayer.stdin.write('quit\n')
	
	def __init__(self, url, options) :
		self.play(url, options)
		

class Record :
	record = None
	
	def start(self, url, output) :
		cmd = 'mimms '+url+' '+output
		self.record = subprocess.Popen(cmd, shell=True, bufsize=0, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, close_fds=True)
	
	def stop(self) :
		self.record.terminate()
	
	def __init__(self, url, output) :
		self.start(url, output)

def main() :
	print 'Wto (version '+WTO_VERSION+') - La WebTv d\'Orange sans Firefox'
	print """
Ce programme est sous licence GPL v3
Ce programme est basé sur le script bash écrit par papaneo (http://forum.ubuntu-fr.org/profile.php?id=117523)
	
(c) 2009 - TuxGasy <tuxgasy@tuxfamily.org>
(c) 2010 - Loïc GRENON <difool@tuxfamily.org>
	"""
	
	#if os.access(WTO_LOCK_FILE, os.F_OK) :
		#return
	
	#création du fichier de lock
	#os.mknod(WTO_LOCK_FILE)
	
	# création du dossier .wto dans le home
	if not os.access(WTO_USER_HOME, os.F_OK | os.W_OK) :
		print 'Création du répertoire '+WTO_USER_HOME+'...'
		os.mkdir(WTO_USER_HOME)
	
	# création du dossier d'enregistrement
	if not os.access(WTO_RECORDS_DIR, os.F_OK | os.W_OK) :
		print 'Création du répertoire '+WTO_RECORDS_DIR+'...'
		os.mkdir(WTO_RECORDS_DIR)
	
	# création du dossier de cache
	if not os.access(WTO_CACHE_DIR, os.F_OK | os.W_OK) :
		print 'Création du répertoire '+WTO_CACHE_DIR+'...'
		os.mkdir(WTO_CACHE_DIR)
	
	# création du dossier de cache des icônes
	if not os.access(WTO_CHANNELS_ICONS, os.F_OK | os.W_OK) :
		print 'Création du répertoire '+WTO_CHANNELS_ICONS+'...'
		os.mkdir(WTO_CHANNELS_ICONS)

	config = Config()
	MainIterface(config)
	
	# Effacer le fichier de lock
	#os.remove(WTO_LOCK_FILE)

if __name__ == '__main__' : main()
